package com.example.demo.service;

import com.example.demo.model.Student;
import com.example.demo.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class StudentService {
    @Autowired
    private StudentRepository studentRepository;

    public Flux<Student> getStudents() {
        return studentRepository.findAll();
    }

    public Mono<Student> findById(Integer id) {
        return studentRepository.findById(id);
    }

    public Mono<Student> addStudent(Student student) {
        return studentRepository.save(student);
    }

    public Mono<Student> update(Student student){
        return studentRepository.save(student);
    }

    public Mono<Void> delete(Integer id) {
        return studentRepository.deleteById(id);
    }


}
